package com.securitycontrol.system.api.factory;

import com.securitycontrol.system.api.domain.decision.SysMenu;
import com.securitycontrol.system.api.domain.decision.SysUserVo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;
import com.securitycontrol.common.core.domain.Result;
import com.securitycontrol.system.api.RemoteUserService;
import com.securitycontrol.system.api.model.LoginUser;

import java.util.List;


/**
 * 用户服务降级处理
 *
 * @author czc
 */
@Component
public class RemoteUserFallbackFactory implements FallbackFactory<RemoteUserService>
{
    private static final Logger log = LoggerFactory.getLogger(RemoteUserFallbackFactory.class);

    @Override
    public RemoteUserService create(Throwable throwable) {
        log.error("用户服务调用失败:{}", throwable.getMessage());
        return new RemoteUserService() {
            @Override
            public Result<LoginUser> getUserInfo(String username, String source) {
                return Result.fail("获取用户失败:" + throwable.getMessage());
            }

            @Override
            public Result<List<String>> getMenulPer(String username, String source) {
                return Result.fail("获取用户按钮失败:" + throwable.getMessage());
            }

            @Override
            public Result<List<SysMenu>> getAllMenuList(String username, String source) {
                return Result.fail("获取菜单失败:" + throwable.getMessage());
            }

            @Override
            public Result<SysUserVo> getUserById(String userId, String source) {
                return Result.fail("获取用户失败:" + throwable.getMessage());
            }
            @Override
            public void updateUserLogin(Long userId, String source) {
            }

        };
    }
}
